## Script (Python) "pay_online"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# $Id: pay_interswitch.py 2664 2007-11-15 14:35:05Z henrik $
"""
pay online
"""
from urllib import urlencode
import logging
logger = logging.getLogger('Skins.pay_interswitch')
import DateTime

if context.portal_membership.isAnonymousUser():
    return None

try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass
request = context.REQUEST
wftool = context.portal_workflow
students = context.portal_url.getPortalObject().campus.students


student_id = context.getStudentId()
student = getattr(students,student_id)

student_record = context.students_catalog.getRecordByKey(student_id)
#amount,description = context.getSchoolFee(student_record.faculty,student_record.session,student_record.course)
info = {}
info['student'] = student_record
info['payment_possible'] = False
info['amount'] = '0'
info['bank'] = ''
info['type_description'] = ''
info['pay_bill_to'] = ''
fee_dict = context.getSchoolFee(student_record)
fulltime = student_record.mode.endswith('_ft')
new = student_record.review_state == 'cleared_and_validated'
returning = student_record.review_state == 'returning'
if not fee_dict or (not new and fulltime) or not (new or returning):
    return context.interswitch_form(info=info)
info['site_id'] = '61'
info['currency_id'] = '566'
if new:
    amount = info['amount'] = fee_dict['new']
elif returning:
    amount = info['amount'] = fee_dict['returning']
if fulltime:
    pay_item_id = "6100"
    #info['type_code'] = student_record.faculty   #type_code is redundant and will be removed soon
    info['bank'] = ''
else:
    pay_item_id = "6101"
    #info['type_code'] = student_record.course  #type_code is redundant and will be removed soon
    info['bank'] = ''
info['payment_possible'] = True
info['type_description'] = fee_dict['description']
info['pay_bill_to'] = student_record.name
info['pay_ship_to'] = "University of Benin"
info['student_id'] = student_id
info['student_name'] = student_record.name
info['student_email'] = student_record.email
info['session_id'] = student_record.session
info['type'] = 'online'
info['status'] = 'started'
info['target'] = student_record.course
info['subject'] = 'schoolfee'
now = DateTime.DateTime()
info['date'] = now
timestamp = "%d" % int(now.timeTime()*1000)
info['order_id'] = "%s%s" % (student_id[1:],timestamp)
p_id = "p%s" % timestamp

if student_id is None:
    return context.REQUEST.RESPONSE.redirect("%s/srp_anonymous_view" % context.portal_url())

if True or context.portal_url().find('uniben-demo.waeup.org') >-1 or\
   context.portal_url().find('uniben.waeup.org') >-1:
    info['action'] = "https://webpay.interswitchng.com/paydirect/webpay/pay.aspx"
else:
    #pass
    #return None
    info['action'] = "%s/payments/%s/simulate_callback" % (student.absolute_url(),p_id)


if "payments" not in student.objectIds():
    student.invokeFactory('PaymentsFolder','payments')
    payments = getattr(student,'payments')
    d = {}
    d['Title'] = 'Payments'
    payments.getContent().edit(mapping=d)
    wftool.doActionFor(payments,'open')
else:
    payments = getattr(student,'payments')
if request.has_key('epayment'):
    return context.interswitch_form(info=info)


payments.invokeFactory('Payment', p_id)
payment = getattr(payments,p_id)
wftool.doActionFor(payment,'open')
d = {}
d.update(info)
#from Products.zdb import set_trace;set_trace()
payment.getContent().edit(mapping=d)
#wftool.doActionFor(payment,'close')
#wftool.doActionFor(student,'pay_school_fee')
info['callback_url'] = "%s/payments/%s/interswitch_cb?echo=%s" % (student.absolute_url(),
                                                                  p_id,
                                                                  p_id)

logger.info('%(student_id)s initiated online school fee payment with order_id %(order_id)s and callback url %(callback_url)s' % info)
payment_fields = (('product_id','site_id'),
                  ('site_redirect_url','callback_url'),
                  ('Currency','currency_id'),
                  ('cust_id','student_id'),
                  ('cust_id_desc','type_description'),
                  ('cust_name','student_name'),
                  ('txn_ref','order_id'),
                  ('Amount','amount'),
                  )
args = {}
for arg,field in payment_fields:
    args[arg] = info[field]
itotal = int(amount)*100
wema_amount = 10000
provider_amount = 35000
interswitch_amount = 15000
#uniben_amount = itotal - wema_amount - provider_amount - interswitch_amount
uniben_amount = itotal - interswitch_amount
xmldict = {}
xmldict['detail_ref'] = args['txn_ref']
xmldict['department'] = student_record.department
xmldict['faculty'] = student_record.faculty
#xmldict['wema_amt'] = "%d" % wema_amount
#xmldict['provider_amt'] = "%d" % provider_amount
xmldict['uniben_amt'] = "%d" % uniben_amount
##<item_detail item_id="2" item_name="WEMA" item_amt="%(wema_amt)s" bank_id="16" acct_num="48398023902" />
##<item_detail item_id="3" item_name="Portal Provider" item_amt="%(provider_amt)s" bank_id="47" acct_num="0980938209483" />
xmltext = """
<payment_item_detail>
<item_details detail_ref="%(detail_ref)s" college="UNIBEN" department="%(department)s"
faculty="%(faculty)s">
<item_detail item_id="1" item_name="UNIBEN" item_amt="%(uniben_amt)s" bank_id="16" acct_num="384950902390" />
</item_details>
</payment_item_detail>
""" % xmldict
#total = int(xmldict['uniben_amt'])+int(xmldict['wema_amt'])+int(xmldict['provider_amt'])
total = int(xmldict['uniben_amt'])
args['Amount'] = "%d" % (total + 15000)
args['site_name'] = "uniben.waeup.org"
args['cust_name_desc'] = "Student Name"
args['pay_item_id'] = pay_item_id
args['pay_item_name'] = "UNIBEN Tuition Payments"
args['payment_params'] = 'switch_college_split'
#args['xml_data'] = xmltext % info
args['xml_data'] = ''
info['args'] = args
return context.goto_interswitch_form(info=info)
